package es.uv.saic.web;

import java.math.BigInteger;

import es.uv.saic.domain.InstanciaTasca;
import es.uv.saic.domain.Tasca;
import es.uv.saic.dto.InstanciaTascaDTO;
import es.uv.saic.dto.NomProcesOrganDTO;
import es.uv.saic.dto.ProcesDTO;
import es.uv.saic.dto.TascaDTO;
import es.uv.saic.dto.TascaInformeTransferDTO;
import es.uv.saic.service.InstanciaTascaService;
import es.uv.saic.service.TascaService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;


@RestController
public class TascaController {
    @Autowired
    TascaService ts;

    @Autowired
    InstanciaTascaService its;

    @GetMapping("/instanciatasca/{id}")
    public ResponseEntity<?> findInstanciaTascaById(@PathVariable("id") BigInteger id) {
        try {
            InstanciaTascaDTO instanciatasca = its.findByIdDTO(id);

            return (instanciatasca != null) ? 
            ResponseEntity.ok(instanciatasca) : ResponseEntity.badRequest().body("La instancia esta vacia");
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.badRequest().body("Error al obtener la instancia por el id:" +  e.getMessage());
        }
    }

    @GetMapping("/instanciatasca2/{id}")
    public ResponseEntity<?> findInstanciaTascaById2(@PathVariable("id") BigInteger id) {
        try {
            InstanciaTasca instanciatasca = its.findById(id);
            InstanciaTascaDTO instanciaTascaDTO = new InstanciaTascaDTO(instanciatasca);

            return (instanciaTascaDTO != null) ? 
            ResponseEntity.ok(instanciaTascaDTO) : ResponseEntity.badRequest().body("La instancia esta vacia");
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.badRequest().body("Error al obtener la instancia por el id:" +  e.getMessage());
        }
    }

    @PostMapping("/getLastByProcName")
    public ResponseEntity<?> getLastByProcName(@RequestBody ProcesDTO tascaDTO) {
        try {
            TascaInformeTransferDTO tit = its.getLastByProcName(tascaDTO.getNomProces(),
                tascaDTO.getLugar(), tascaDTO.getLugar2(), tascaDTO.getTambit());

            return ResponseEntity.ok(tit);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.badRequest().body("Error al obtener la última tarea a partir del procedimiento: " + e.getMessage());
        }
    }
    
    @PostMapping("/getByProcesTascap/{idProces}/{idTascap}")
    public ResponseEntity<?> getByProcesTascap(@PathVariable Integer idProces, @PathVariable Integer idTascap) {
        try {
            Tasca tasca = ts.getByProcesTascap(idProces, idTascap);
            TascaDTO tascaDTO = new TascaDTO(tasca);

            return ResponseEntity.ok(tascaDTO);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.badRequest().body("Error al obtener la tasca: " + e.getMessage());
        }
    }
    
    @GetMapping("/getReportFromNomProcesOrgan")
    public ResponseEntity<?> getReportFromNomProcesOrgan(@RequestBody NomProcesOrganDTO nomProcesOrganDTO) {
        try {
            InstanciaTasca itasca = its.getReportFromNomProcesOrgan(nomProcesOrganDTO.getNomProces(), nomProcesOrganDTO.getTlugar(), nomProcesOrganDTO.getLugar(), nomProcesOrganDTO.getCentre(), nomProcesOrganDTO.getTitulacio());
            InstanciaTascaDTO itDto = new InstanciaTascaDTO(itasca);

            return ResponseEntity.ok(itDto);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.badRequest().body("Error al obtener la instancia tasca: " + e.getMessage());
        }
    }
}
